        // type used for signal/slot
        typedef python::class_<pyqt_slot> pyqt_slot_type;
        pyqt_slot_type pyqt_slot_cls("pyqt_slot",
                                     python::init<const QByteArray>());
        pyqt_slot_cls.def("__str__", &pyqt_slot_to_str);

        typedef python::class_<pyqt_signal,
                               python::bases<pyqt_slot> > pyqt_signal_type;
        pyqt_signal_type pyqt_signal_cls("pyqt_signal",
                                         python::init<const QByteArray>());
        python_cls
            /**[sphinx-begin]
             *
             *  .. method:: QObject.connect(signal, callback)
             *      .. param: signal - name of the signal
             *      .. param: callback - Python method to call when signal is fired
             *
             *      Connect a QObject Singal to Python callbak
             [sphinx-end]**/
            .def("connect", connect_python_signal)
            .def("connect", connect_python_signal2)
            .def("connect", connect_python_signal3)
            .def("connect", connect_python_signal4)
            .def("connect", connect_python_signal5)
            .def("disconnect", disconnect_python_signal)
            .def("disconnect", disconnect_python_signal2)
            .def("disconnect", disconnect_python_signal3)
            .def("disconnect", disconnect_python_signal4)
            /**[sphinx-begin]
             *
             *  .. method:: QObject.emit(signal, args)
             *      .. param: signal - callback
             *      .. param: args - List of arguments
             *
             *      Call all callbacks connected with this signal using args
             [sphinx-end]**/
            .def("emit", python::raw_function(emit_python_signal))
            .def("findChildren", qobject_find_children,
                (python::arg("name")=""))
            .def("findChild", qobject_find_child,
                (python::arg("name")=""))
            .def("inherits", qobject_inherits)
            .def("tr", qobject_tr,
                (python::arg(""), python::arg(""),
                 python::arg("")="",python::arg("")=-1))
            .def("trUtf8", qobject_trutf8,
                (python::arg(""), python::arg(""),
                 python::arg("")="",python::arg("")=-1))
#ifndef NDEBUG
            //debug function
            .def("dump_", _qobject_dump)
#endif
            // metaObject method
            .def("metaObject", qobject_metaObject,
                  python::return_value_policy< python::reference_existing_object>())
        ;
